# Functions

## Physical units

```@autodocs
Modules = [FinEtools, FinEtools.PhysicalUnitModule]
Private = true
Order = [:function]
```

## Bounding box functions

```@autodocs
Modules = [FinEtools, FinEtools.BoxModule]
Private = true
Order = [:function]
```

## Coordinate systems

```@autodocs
Modules = [FinEtools, FinEtools.CSysModule]
Private = true
Order = [:function]
```

## Matrix utilities

```@autodocs
Modules = [FinEtools, FinEtools.MatrixUtilityModule]
Private = true
Order = [:function]
```

## Finite element sets

```@autodocs
Modules = [FinEtools, FinEtools.FESetModule]
Private = true
Order = [:function]
```

## Finite element nodes

```@autodocs
Modules = [FinEtools, FinEtools.FENodeSetModule]
Private = true
Order = [:function]
```

## Finite element node-to-element map

```@autodocs
Modules = [FinEtools, FinEtools.FENodeToFEMapModule]
Private = true
Order = [:function]
```

## Selecting nodes and elements

```@autodocs
Modules = [FinEtools, FinEtools.MeshSelectionModule]
Private = true
Order = [:function]
```

## Fields

```@autodocs
Modules = [FinEtools, FinEtools.FieldModule, FinEtools.GeneralFieldModule, FinEtools.NodalFieldModule, FinEtools.ElementalFieldModule]
Private = true
Order = [:function]
```

## Integration rule

```@autodocs
Modules = [FinEtools, FinEtools.IntegRuleModule]
Private = true
Order = [:function]
```

## Integration domain

```@autodocs
Modules = [FinEtools, FinEtools.IntegDomainModule]
Private = true
Order = [:function]
```

## Assembly of matrices and vectors

```@autodocs
Modules = [FinEtools, FinEtools.AssemblyModule]
Private = true
Order = [:function]
```

## Meshing

### Meshing with line elements

```@autodocs
Modules = [FinEtools, FinEtools.MeshLineModule]
Private = true
Order = [:function]
```

### Meshing with triangles

```@autodocs
Modules = [FinEtools, FinEtools.MeshTriangleModule]
Private = true
Order = [:function]
```

### Meshing with quadrilaterals

```@autodocs
Modules = [FinEtools, FinEtools.MeshQuadrilateralModule]
Private = true
Order = [:function]
```

### Meshing with tetrahedra

```@autodocs
Modules = [FinEtools, FinEtools.MeshTetrahedronModule, FinEtools.VoxelBoxModule, FinEtools.VoxelTetMeshingModule]
Private = true
Order = [:function]
```

### Meshing with hexahedra

```@autodocs
Modules = [FinEtools, FinEtools.MeshHexahedronModule]
Private = true
Order = [:function]
```

### Mesh selection

See above as "Selecting nodes and elements".

### Mesh modification

```@autodocs
Modules = [FinEtools, FinEtools.MeshModificationModule]
Private = true
Order = [:function]
```

### Meshing utilities

```@autodocs
Modules = [FinEtools, FinEtools.MeshUtilModule]
Private = true
Order = [:function]
```

### Mesh import

```@autodocs
Modules = [FinEtools, FinEtools.MeshImportModule]
Private = true
Order = [:function]
```

### Mesh export

#### VTK
```@autodocs
Modules = [FinEtools, FinEtools.MeshExportModule.VTK]
Private = true
Order = [:function]
```

#### Abaqus
```@autodocs
Modules = [FinEtools, FinEtools.MeshExportModule.Abaqus]
Private = true
Order = [:function]
```

#### NASTRAN
```@autodocs
Modules = [FinEtools, FinEtools.MeshExportModule.NASTRAN]
Private = true
Order = [:function]
```

#### STL
```@autodocs
Modules = [FinEtools, FinEtools.MeshExportModule.STL]
Private = true
Order = [:function]
```

#### CSV
```@autodocs
Modules = [FinEtools, FinEtools.MeshExportModule.CSV]
Private = true
Order = [:function]
```

#### H2Lib
```@autodocs
Modules = [FinEtools, FinEtools.MeshExportModule.H2Lib]
Private = true
Order = [:function]
```


## Vector-cache utilities

```@autodocs
Modules = [FinEtools, FinEtools.VectorCacheModule]
Private = true
Order = [:function]
```

## Surface-normal utilities

```@autodocs
Modules = [FinEtools, FinEtools.SurfaceNormalModule]
Private = true
Order = [:function]
```

## Force intensity

```@autodocs
Modules = [FinEtools, FinEtools.ForceIntensityModule]
Private = true
Order = [:function]
```

## Rotation utilities

```@autodocs
Modules = [FinEtools, FinEtools.RotationUtilModule]
Private = true
Order = [:function]
```

## FEM machines

### Base

```@autodocs
Modules = [FinEtools, FinEtools.FEMMBaseModule]
Private = true
Order = [:function]
```

## Algorithms

### Base

```@autodocs
Modules = [FinEtools, FinEtools.AlgoBaseModule]
Private = true
Order = [:function]
```

## Material models

### Material model abstractions

```@autodocs
Modules = [FinEtools, FinEtools.MatModule]
Private = true
Order = [:function]
```
